<?php
jimport( 'joomla.application.categories' );
jimport('joomla.application.component.helper');

class ProductadvisorCategories extends JCategories
{
	public function __construct($options = array())
	{
		$options['table'] = '#__content';
		$options['extension'] = 'com_productadvisor';
		parent::__construct($options);
	}
}

class ProductadvisorCategoryHelper  {
	static protected $_categoryKeys = array("id", "asset_id", "parent_id", "lft", "rgt", "level", "extension", "title", "alias", "description", "published", "checked_out", "checked_out_time", "access", "params", "metadesc", "metakey", "metadata", "created_user_id", "created_time", "modified_user_id", "modified_time", "hits", "language", "numitems", "childrennumitems", "slug", "assets", "path", "note");
	static protected $_extension = 'com_productadvisor';
	static protected $_extensionName = 'Productadvisor';
	
	public static function getSingle($id) {
		$return = JCategories::getInstance(self::$_extensionName);
		return $return->get($id);
	}
	
	public static function get($ext) {
		return JCategories::getInstance($ext)->get('root');
	}
	
	public static function getAttributelist($emptyPreSelect = TRUE) {
		$list = self::getFlat('Productadvisor', JComponentHelper::getParams('com_productadvisor')->get('COM_PRODUCTADVISOR_PRODUCTATTRIBUTE_ROOT_CATEGORY'));
		if($emptyPreSelect) {array_unshift($list, (object) array("id"=>0, "title"=>JText::_('COM_PRODUCTADVISOR_SHOWALL')));}
		return $list;
	}
	public static function getCategorylist($emptyPreSelect = TRUE) {
		$list = self::getFlat('Productadvisor', JComponentHelper::getParams('com_productadvisor')->get('COM_PRODUCTADVISOR_PRODUCTCATEGORY_ROOT_CATEGORY'));
		if($emptyPreSelect) {array_unshift($list, (object) array("id"=>0, "title"=>JText::_('COM_PRODUCTADVISOR_SHOWALL')));}
		return $list;
	}

	public static function getFlat($extension = NULL, $id='root', $outputKeys = NULL) {
		if(is_null($extension)) $extension = self::$_extensionName;
		$c = array();
		$result = array();
		$root = ProductadvisorCategories::getInstance($extension)->get($id);
		
		if($root->hasChildren()) {
			$c = self::_getFlat($root, $c);
		} else {
			$c = array($root);
		}
		for($i=0; $i<count($c); $i++) {
			$result[] = self::simplify($c[$i], $outputKeys);
		}
		return $result;
	}
	/**
	*	Denkfehler mit $array!
	*/
	private static function _getFlat(JCategoryNode $root, &$array = NULL) {
		if(is_null($array)) {
			$r = array();
		} else {
			$r = $array;
		}
		$tmp = $root->getChildren(TRUE);
		if($root->hasChildren()) {
			foreach($root->getChildren() as $obj) {
				$r[] = $obj;
				$r = self::_getFlat($obj, $r);
			}
		} else {
// 			$r = array($root);
// 			$r = array();
		}
		return $r;
	}
	
	private static function simplify(JCategoryNode $obj, $outputKeys = NULL) {
		if(is_null($outputKeys)) {
			$outputKeys = self::$_categoryKeys;
		} 
		$c = array();
		foreach($outputKeys as $key) {
			$c[$key] = (isset($obj->$key) ? $obj->$key : NULL);
		}
		return $c;
	}
	
}
?>