<?php
/*------------------------------------------------------------------------
# productadvisor.php - Product advisor Component
# ------------------------------------------------------------------------
# author    Matthias Drobny, drobny.iT
# copyright Copyright (C) 2014. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   www.drobny.it
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Productadvisor component helper
 */
abstract class CMPTDistributionHelper
{
	public static function add($cmptname) {
		$config = &JFactory::getConfig();
		$tmpDir = $config->getValue( 'config.tmp_path' );
		$tmpFile = $tmpDir.DS.$cmptname.".cache";

		if(is_dir($tmpDir)) {
			if(file_exists($tmpFile)) {
				if(is_writeable($tmpFile)) {
					if((filemtime($tmpFile)+86400) < time() ) {
						#	CURL
						self::addRequest($cmptname);
						touch($tmpFile);
					} else {
						return TRUE;
					}
				} else {
					return FALSE;
				}
			} else if(touch($tmpFile)) {
				#	CURL
				self::addRequest($cmptname);
			} else {
				return FALSE;
			}
		} else {
			return FALSE;
		}
	}
	
	private static function addRequest($cmptname) {
		$url = "http://joomla.drobny.it/cmptdistribution/";
		$curl = curl_init();
		curl_setopt_array($curl, array(
			CURLOPT_RETURNTRANSFER => 1,
			CURLOPT_FOLLOWLOCATION => 1,
			CURLOPT_URL => $url,
			CURLOPT_HEADER => 0,
			CURLOPT_POST => 1,
			CURLOPT_POSTFIELDS => array(
				'srcdomain'	=>	addslashes($_SERVER['SERVER_NAME'].dirname($_SERVER['REQUEST_URI'])),
				'cmptname'	=>	addslashes($cmptname),
			)
		));
		$resp = curl_exec($curl);
// 		echo "<!--";
// 		print_r($resp);
// 		print_r(curl_getinfo($curl));
// 		echo "-->";
		curl_close($curl);	
		return TRUE;
	}
}
?>